// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from gazebo_video_monitor_interfaces:srv/SetCamera.idl
// generated code does not contain a copyright notice

#ifndef GAZEBO_VIDEO_MONITOR_INTERFACES__SRV__DETAIL__SET_CAMERA__STRUCT_HPP_
#define GAZEBO_VIDEO_MONITOR_INTERFACES__SRV__DETAIL__SET_CAMERA__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'pose'
#include "gazebo_video_monitor_interfaces/msg/detail/pose__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__gazebo_video_monitor_interfaces__srv__SetCamera_Request __attribute__((deprecated))
#else
# define DEPRECATED__gazebo_video_monitor_interfaces__srv__SetCamera_Request __declspec(deprecated)
#endif

namespace gazebo_video_monitor_interfaces
{

namespace srv
{

// message struct
template<class ContainerAllocator>
struct SetCamera_Request_
{
  using Type = SetCamera_Request_<ContainerAllocator>;

  explicit SetCamera_Request_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : pose(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->camera_name = "";
      this->model_name = "";
      this->link_name = "";
    }
  }

  explicit SetCamera_Request_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : camera_name(_alloc),
    model_name(_alloc),
    link_name(_alloc),
    pose(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->camera_name = "";
      this->model_name = "";
      this->link_name = "";
    }
  }

  // field types and members
  using _camera_name_type =
    std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>;
  _camera_name_type camera_name;
  using _model_name_type =
    std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>;
  _model_name_type model_name;
  using _link_name_type =
    std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>;
  _link_name_type link_name;
  using _pose_type =
    gazebo_video_monitor_interfaces::msg::Pose_<ContainerAllocator>;
  _pose_type pose;

  // setters for named parameter idiom
  Type & set__camera_name(
    const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> & _arg)
  {
    this->camera_name = _arg;
    return *this;
  }
  Type & set__model_name(
    const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> & _arg)
  {
    this->model_name = _arg;
    return *this;
  }
  Type & set__link_name(
    const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> & _arg)
  {
    this->link_name = _arg;
    return *this;
  }
  Type & set__pose(
    const gazebo_video_monitor_interfaces::msg::Pose_<ContainerAllocator> & _arg)
  {
    this->pose = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    gazebo_video_monitor_interfaces::srv::SetCamera_Request_<ContainerAllocator> *;
  using ConstRawPtr =
    const gazebo_video_monitor_interfaces::srv::SetCamera_Request_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<gazebo_video_monitor_interfaces::srv::SetCamera_Request_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<gazebo_video_monitor_interfaces::srv::SetCamera_Request_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      gazebo_video_monitor_interfaces::srv::SetCamera_Request_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<gazebo_video_monitor_interfaces::srv::SetCamera_Request_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      gazebo_video_monitor_interfaces::srv::SetCamera_Request_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<gazebo_video_monitor_interfaces::srv::SetCamera_Request_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<gazebo_video_monitor_interfaces::srv::SetCamera_Request_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<gazebo_video_monitor_interfaces::srv::SetCamera_Request_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__gazebo_video_monitor_interfaces__srv__SetCamera_Request
    std::shared_ptr<gazebo_video_monitor_interfaces::srv::SetCamera_Request_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__gazebo_video_monitor_interfaces__srv__SetCamera_Request
    std::shared_ptr<gazebo_video_monitor_interfaces::srv::SetCamera_Request_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const SetCamera_Request_ & other) const
  {
    if (this->camera_name != other.camera_name) {
      return false;
    }
    if (this->model_name != other.model_name) {
      return false;
    }
    if (this->link_name != other.link_name) {
      return false;
    }
    if (this->pose != other.pose) {
      return false;
    }
    return true;
  }
  bool operator!=(const SetCamera_Request_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct SetCamera_Request_

// alias to use template instance with default allocator
using SetCamera_Request =
  gazebo_video_monitor_interfaces::srv::SetCamera_Request_<std::allocator<void>>;

// constant definitions

}  // namespace srv

}  // namespace gazebo_video_monitor_interfaces


#ifndef _WIN32
# define DEPRECATED__gazebo_video_monitor_interfaces__srv__SetCamera_Response __attribute__((deprecated))
#else
# define DEPRECATED__gazebo_video_monitor_interfaces__srv__SetCamera_Response __declspec(deprecated)
#endif

namespace gazebo_video_monitor_interfaces
{

namespace srv
{

// message struct
template<class ContainerAllocator>
struct SetCamera_Response_
{
  using Type = SetCamera_Response_<ContainerAllocator>;

  explicit SetCamera_Response_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->message = "";
      this->success = false;
    }
  }

  explicit SetCamera_Response_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : message(_alloc)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->message = "";
      this->success = false;
    }
  }

  // field types and members
  using _message_type =
    std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>;
  _message_type message;
  using _success_type =
    bool;
  _success_type success;

  // setters for named parameter idiom
  Type & set__message(
    const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> & _arg)
  {
    this->message = _arg;
    return *this;
  }
  Type & set__success(
    const bool & _arg)
  {
    this->success = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    gazebo_video_monitor_interfaces::srv::SetCamera_Response_<ContainerAllocator> *;
  using ConstRawPtr =
    const gazebo_video_monitor_interfaces::srv::SetCamera_Response_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<gazebo_video_monitor_interfaces::srv::SetCamera_Response_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<gazebo_video_monitor_interfaces::srv::SetCamera_Response_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      gazebo_video_monitor_interfaces::srv::SetCamera_Response_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<gazebo_video_monitor_interfaces::srv::SetCamera_Response_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      gazebo_video_monitor_interfaces::srv::SetCamera_Response_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<gazebo_video_monitor_interfaces::srv::SetCamera_Response_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<gazebo_video_monitor_interfaces::srv::SetCamera_Response_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<gazebo_video_monitor_interfaces::srv::SetCamera_Response_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__gazebo_video_monitor_interfaces__srv__SetCamera_Response
    std::shared_ptr<gazebo_video_monitor_interfaces::srv::SetCamera_Response_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__gazebo_video_monitor_interfaces__srv__SetCamera_Response
    std::shared_ptr<gazebo_video_monitor_interfaces::srv::SetCamera_Response_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const SetCamera_Response_ & other) const
  {
    if (this->message != other.message) {
      return false;
    }
    if (this->success != other.success) {
      return false;
    }
    return true;
  }
  bool operator!=(const SetCamera_Response_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct SetCamera_Response_

// alias to use template instance with default allocator
using SetCamera_Response =
  gazebo_video_monitor_interfaces::srv::SetCamera_Response_<std::allocator<void>>;

// constant definitions

}  // namespace srv

}  // namespace gazebo_video_monitor_interfaces

namespace gazebo_video_monitor_interfaces
{

namespace srv
{

struct SetCamera
{
  using Request = gazebo_video_monitor_interfaces::srv::SetCamera_Request;
  using Response = gazebo_video_monitor_interfaces::srv::SetCamera_Response;
};

}  // namespace srv

}  // namespace gazebo_video_monitor_interfaces

#endif  // GAZEBO_VIDEO_MONITOR_INTERFACES__SRV__DETAIL__SET_CAMERA__STRUCT_HPP_
