// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from gazebo_video_monitor_interfaces:srv/StartGmcmRecording.idl
// generated code does not contain a copyright notice

#ifndef GAZEBO_VIDEO_MONITOR_INTERFACES__SRV__DETAIL__START_GMCM_RECORDING__STRUCT_HPP_
#define GAZEBO_VIDEO_MONITOR_INTERFACES__SRV__DETAIL__START_GMCM_RECORDING__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'cameras'
#include "gazebo_video_monitor_interfaces/msg/detail/strings__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__gazebo_video_monitor_interfaces__srv__StartGmcmRecording_Request __attribute__((deprecated))
#else
# define DEPRECATED__gazebo_video_monitor_interfaces__srv__StartGmcmRecording_Request __declspec(deprecated)
#endif

namespace gazebo_video_monitor_interfaces
{

namespace srv
{

// message struct
template<class ContainerAllocator>
struct StartGmcmRecording_Request_
{
  using Type = StartGmcmRecording_Request_<ContainerAllocator>;

  explicit StartGmcmRecording_Request_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : cameras(_init)
  {
    (void)_init;
  }

  explicit StartGmcmRecording_Request_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : cameras(_alloc, _init)
  {
    (void)_init;
  }

  // field types and members
  using _cameras_type =
    gazebo_video_monitor_interfaces::msg::Strings_<ContainerAllocator>;
  _cameras_type cameras;

  // setters for named parameter idiom
  Type & set__cameras(
    const gazebo_video_monitor_interfaces::msg::Strings_<ContainerAllocator> & _arg)
  {
    this->cameras = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    gazebo_video_monitor_interfaces::srv::StartGmcmRecording_Request_<ContainerAllocator> *;
  using ConstRawPtr =
    const gazebo_video_monitor_interfaces::srv::StartGmcmRecording_Request_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<gazebo_video_monitor_interfaces::srv::StartGmcmRecording_Request_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<gazebo_video_monitor_interfaces::srv::StartGmcmRecording_Request_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      gazebo_video_monitor_interfaces::srv::StartGmcmRecording_Request_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<gazebo_video_monitor_interfaces::srv::StartGmcmRecording_Request_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      gazebo_video_monitor_interfaces::srv::StartGmcmRecording_Request_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<gazebo_video_monitor_interfaces::srv::StartGmcmRecording_Request_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<gazebo_video_monitor_interfaces::srv::StartGmcmRecording_Request_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<gazebo_video_monitor_interfaces::srv::StartGmcmRecording_Request_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__gazebo_video_monitor_interfaces__srv__StartGmcmRecording_Request
    std::shared_ptr<gazebo_video_monitor_interfaces::srv::StartGmcmRecording_Request_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__gazebo_video_monitor_interfaces__srv__StartGmcmRecording_Request
    std::shared_ptr<gazebo_video_monitor_interfaces::srv::StartGmcmRecording_Request_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const StartGmcmRecording_Request_ & other) const
  {
    if (this->cameras != other.cameras) {
      return false;
    }
    return true;
  }
  bool operator!=(const StartGmcmRecording_Request_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct StartGmcmRecording_Request_

// alias to use template instance with default allocator
using StartGmcmRecording_Request =
  gazebo_video_monitor_interfaces::srv::StartGmcmRecording_Request_<std::allocator<void>>;

// constant definitions

}  // namespace srv

}  // namespace gazebo_video_monitor_interfaces


#ifndef _WIN32
# define DEPRECATED__gazebo_video_monitor_interfaces__srv__StartGmcmRecording_Response __attribute__((deprecated))
#else
# define DEPRECATED__gazebo_video_monitor_interfaces__srv__StartGmcmRecording_Response __declspec(deprecated)
#endif

namespace gazebo_video_monitor_interfaces
{

namespace srv
{

// message struct
template<class ContainerAllocator>
struct StartGmcmRecording_Response_
{
  using Type = StartGmcmRecording_Response_<ContainerAllocator>;

  explicit StartGmcmRecording_Response_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->structure_needs_at_least_one_member = 0;
    }
  }

  explicit StartGmcmRecording_Response_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    (void)_alloc;
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->structure_needs_at_least_one_member = 0;
    }
  }

  // field types and members
  using _structure_needs_at_least_one_member_type =
    uint8_t;
  _structure_needs_at_least_one_member_type structure_needs_at_least_one_member;


  // constant declarations

  // pointer types
  using RawPtr =
    gazebo_video_monitor_interfaces::srv::StartGmcmRecording_Response_<ContainerAllocator> *;
  using ConstRawPtr =
    const gazebo_video_monitor_interfaces::srv::StartGmcmRecording_Response_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<gazebo_video_monitor_interfaces::srv::StartGmcmRecording_Response_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<gazebo_video_monitor_interfaces::srv::StartGmcmRecording_Response_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      gazebo_video_monitor_interfaces::srv::StartGmcmRecording_Response_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<gazebo_video_monitor_interfaces::srv::StartGmcmRecording_Response_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      gazebo_video_monitor_interfaces::srv::StartGmcmRecording_Response_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<gazebo_video_monitor_interfaces::srv::StartGmcmRecording_Response_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<gazebo_video_monitor_interfaces::srv::StartGmcmRecording_Response_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<gazebo_video_monitor_interfaces::srv::StartGmcmRecording_Response_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__gazebo_video_monitor_interfaces__srv__StartGmcmRecording_Response
    std::shared_ptr<gazebo_video_monitor_interfaces::srv::StartGmcmRecording_Response_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__gazebo_video_monitor_interfaces__srv__StartGmcmRecording_Response
    std::shared_ptr<gazebo_video_monitor_interfaces::srv::StartGmcmRecording_Response_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const StartGmcmRecording_Response_ & other) const
  {
    if (this->structure_needs_at_least_one_member != other.structure_needs_at_least_one_member) {
      return false;
    }
    return true;
  }
  bool operator!=(const StartGmcmRecording_Response_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct StartGmcmRecording_Response_

// alias to use template instance with default allocator
using StartGmcmRecording_Response =
  gazebo_video_monitor_interfaces::srv::StartGmcmRecording_Response_<std::allocator<void>>;

// constant definitions

}  // namespace srv

}  // namespace gazebo_video_monitor_interfaces

namespace gazebo_video_monitor_interfaces
{

namespace srv
{

struct StartGmcmRecording
{
  using Request = gazebo_video_monitor_interfaces::srv::StartGmcmRecording_Request;
  using Response = gazebo_video_monitor_interfaces::srv::StartGmcmRecording_Response;
};

}  // namespace srv

}  // namespace gazebo_video_monitor_interfaces

#endif  // GAZEBO_VIDEO_MONITOR_INTERFACES__SRV__DETAIL__START_GMCM_RECORDING__STRUCT_HPP_
